 #include "lwp.h"
#include <dpmi.h>
#include <dos.h>
#include <stdlib.h>
#include <math.h>
#include <sys/farptr.h>
#include <go32.h>
#include <time.h>
#include <conio.h>
#include <stdio.h>
#include <ctype.h>

#define BLOB_COUNT 250  /* 250 threads */
#define CENTERY 0.0
#define CENTERX 0.0
volatile int plot_count = 0;
void putpixel(int x, int y, char col);
void blob_proc(void);
void waitVBL(void);
void getNewCoords(float *x, float *y,float *xspeed,float *yspeed,float centerx,float centery);
float gravConst = 0.0025;
int main()
{
	int i;
	char answer = 0;
	int ids[BLOB_COUNT];
	__dpmi_regs regs;
	regs.x.ax = 0x13;
	srandom(time(0));
	__dpmi_int(0x10, &regs);
	_farsetsel(_go32_conventional_mem_selector());
	lwp_init();
	for(i=0;i<BLOB_COUNT;i++)
		{
		ids[i] = lwp_spawn(blob_proc, 4096, 1);
		}
	while((toupper(answer) != 'Q'))
		{
		while(!kbhit())
			{
			if(plot_count >= BLOB_COUNT)
				{
				plot_count = 0;
				putpixel(0,0,90);
				waitVBL();
				}	
			lwp_yield();
			}
		answer = toupper(getch());
		if (answer == 'U')
			{
			gravConst+=0.001;
			}
		if (answer == 'D')
			{
			gravConst-=0.001;
			}
		if (answer == 'N')
			{
			lwp_spawn(blob_proc, 4096, 1);
			}
		}
	for(i=0;i<BLOB_COUNT;i++)
		{
		lwp_kill(ids[i]);
		}
	regs.x.ax = 0x3;
	__dpmi_int(0x10, &regs);
	return(0);
}

void blob_proc(void)
{
	float x, y, xspeed,yspeed;
	char col;
        x = (float) ((random() & 50) - 25);
	y = (float) ((random() & 30) - 15);
	col = 50;	
	xspeed = (float) ((random() & 1) - 0.5);
	yspeed = (float) ((random() & 1) - 0.5);
	while(1)
		{
		putpixel((int) x,(int) y,col);	
		plot_count++;
		lwp_yield();
		putpixel((int) x,(int) y,0); 
		/* get new X,Y position from vector function */
		getNewCoords(&x,&y,&xspeed,&yspeed,CENTERX, CENTERY);
		}
}	
 
void putpixel(int x, int y, char col)
{
 	if(!((x < -159) || (x > 159) || (y < -99) || (y > 99)))	
		{
		x+=159;
		y+=99;
		_farnspokeb(0xA0000+x+(y<<6)+(y<<8), col);
		}
}

void waitVBL(void)
{
	while(!(inportb(0x3DA) & 8));
	while(inportb(0x3DA) & 8);
}

void getNewCoords(float *x, float *y,float *xspeed,float *yspeed,float centerx,float centery)
{
        float tmp1, tmp2, tmp3, tmp4;
	float divisor1, divisor2;
        tmp1 = (centerx)-(*xspeed)-(*x);
        tmp2 = (centery)-(*yspeed)-(*y);     
	divisor1 = sqrt((tmp1*tmp1)+(tmp2*tmp2));
	divisor2 = ((centerx-(*xspeed))*(centerx-(*xspeed)))+((centery-(*yspeed))*(centery-(*yspeed)));
        if((divisor1 != 0) && (divisor2 != 0))
                {
		tmp3 = tmp1/divisor1;
		tmp4 = tmp2/divisor1;
		(*xspeed) = ((*xspeed) + tmp3*gravConst/divisor2);
		(*yspeed) = ((*yspeed) + tmp4*gravConst/divisor2);
		(*x) += (*xspeed);
		(*y) += (*yspeed);
                }
        else
                {
		(*x) += (*xspeed);
		(*y) += (*yspeed);
                }
}
